=== debian/changelog ===
pyhailort (4.19.0-2) bookworm; urgency=medium

  * d/control: relax hailort version requirement

 -- Serge Schneider <serge@raspberrypi.com>  Thu, 14 Nov 2024 12:41:17 +0000

pyhailort (4.19.0-1) bookworm; urgency=medium

  * Update to 4.19.0

 -- Serge Schneider <serge@raspberrypi.com>  Wed, 13 Nov 2024 11:01:50 +0000

pyhailort (4.18.0-1) bookworm; urgency=medium

  * Initial release.

 -- Serge Schneider <serge@raspberrypi.com>  Mon, 12 Aug 2024 09:52:48 +0000
