## pyhailort 4.20.0

=== hailort/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 
 # Set firmware version
 add_definitions( -DFIRMWARE_VERSION_MAJOR=4 )
-add_definitions( -DFIRMWARE_VERSION_MINOR=19 )
+add_definitions( -DFIRMWARE_VERSION_MINOR=20 )
 add_definitions( -DFIRMWARE_VERSION_REVISION=0 )
 if(HAILO_BUILD_SERVICE)
     add_definitions( -DHAILO_SUPPORT_MULTI_PROCESS )
@@ -59,10 +59,7 @@
 set(HRPC_PROTOCOL_DIR ${PROJECT_SOURCE_DIR}/hailort/hrpc_protocol)
 set(HAILORT_SERVICE_DIR ${PROJECT_SOURCE_DIR}/hailort/hailort_service)
 set(HAILORT_SERVER_DIR ${PROJECT_SOURCE_DIR}/hailort/hailort_server)
-
-if(CMAKE_SYSTEM_NAME STREQUAL QNX)
-    include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/pevents.cmake)
-endif()
+set(HAILORT_LIBUSB_DIR ${PROJECT_SOURCE_DIR}/hailort/internals/libusb-wrapper/)
 
 if(HAILO_BUILD_SERVICE)
     add_subdirectory(rpc)
@@ -74,9 +71,8 @@
 add_subdirectory(libhailort)
 add_subdirectory(hailortcli)
 if(HAILO_INTERNAL_BUILD)
-    add_subdirectory(tools/hw_debug)
-    add_subdirectory(tools/pcie_tunnel)
-    add_subdirectory(tools/loopback_server)
+    add_subdirectory(tools)
+    add_subdirectory(internals)
 endif()
 
 if(HAILO_BUILD_SERVICE)
