=== hailort/hailort_server/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
 cmake_minimum_required(VERSION 3.5.0)
-
-include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/spdlog.cmake)
-include(${HAILO_EXTERNALS_CMAKE_SCRIPTS}/readerwriterqueue.cmake)
 
 set(THREADS_PREFER_PTHREAD_FLAG ON)
 find_package(Threads REQUIRED)
@@ -11,7 +8,6 @@
     ${HRPC_CPP_SOURCES}
     ${HRPC_PROTOCOL_CPP_SOURCES}
     ${HAILORT_SERVICE_DIR}/cng_buffer_pool.cpp
-    ${HAILO_FULL_OS_DIR}/event.cpp # TODO HRT-10681: move to common
     ${DRIVER_OS_DIR}/driver_os_specific.cpp
     ${HAILORT_SRC_DIR}/vdma/pcie_session.cpp
     ${HAILORT_SRC_DIR}/vdma/memory/descriptor_list.cpp
@@ -23,8 +19,6 @@
     ${HAILORT_SRC_DIR}/vdma/channel/boundary_channel.cpp
     ${HAILORT_SRC_DIR}/vdma/channel/channels_group.cpp
     ${HAILORT_SRC_DIR}/vdma/channel/transfer_common.cpp
-
-    ${HAILORT_COMMON_CPP_SOURCES}
 )
 
 add_executable(hailort_server ${HAILORT_SERVER_SOURCES})
@@ -40,12 +34,5 @@
     libhailort
     Threads::Threads
     rpc_proto
-    spdlog::spdlog
-    readerwriterqueue
+    hailort_common
 )
-if(WIN32)
-    target_link_libraries(hailort_server PRIVATE Ws2_32 Iphlpapi Shlwapi winmm.lib)
-elseif(NOT CMAKE_SYSTEM_NAME STREQUAL Android)
-    # TODO: HRT-14770 fix android build
-    target_link_libraries(hailort_server PRIVATE rt)
-endif()
