=== hailort/prepare_externals/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,7 @@
 include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/dotwriter.cmake)
 include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/benchmark.cmake)
 include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/readerwriterqueue.cmake)
+include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/xxhash.cmake)
 include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/eigen.cmake)
 include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/cli11.cmake)
 include(${CMAKE_CURRENT_LIST_DIR}/../cmake/external/protobuf.cmake)
