=== hailort/libhailort/examples/CMakeLists.txt ===
--- 
+++ 
@@ -30,5 +30,4 @@
 
 # We add a costum target in order to compile all of the hailort examples
 add_custom_target(hailort_examples)
-
 add_dependencies(hailort_examples c_hailort_examples cpp_hailort_examples)
