=== debian/changelog ===
pyhailort (4.20.0-1) bookworm; urgency=medium

  * Update to 4.20.0

 -- Serge Schneider <serge@raspberrypi.com>  Mon, 27 Jan 2025 21:31:17 +0000
