=== debian/control ===
Source: pyhailort
Section: libs
Priority: optional
Maintainer: Serge Schneider <serge@raspberrypi.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 cmake,
 hailort (>= 4.19.0),
 python3-setuptools,
 python3-all,
 python3-dev,
 python3-pybind11,
 python3-verboselogs,
 python3-wheel,
Standards-Version: 4.6.2
Homepage: https://hailo.ai/
Vcs-Browser: https://github.com/hailo-ai/hailort/
Vcs-Git: https://github.com/hailo-ai/hailort.git

Package: python3-hailort
Architecture: arm64
Depends:
 ${python3:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
 hailort (>= 4.19.0),
Description: HailoRT Python API, which wraps the runtime library
 HailoRT is a lightweight, production-grade runtime library that runs on the
 host processor and provides a robust user-space library (the HailoRT Library)
 with intuitive APIs in C/C++ for optimized performance.
 .
 This package installs the library for Python 3.
